All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
utils.hpp File Reference
`#include <vector>`
`#include "viennacl/scheduler/forwards.h"`
`#include "viennacl/device_specific/tree_parsing.hpp"`
`#include "viennacl/device_specific/utils.hpp"`

Go to the source code of this file.

## Namespaces

| viennacl
| Main namespace in ViennaCL. Holds all the basic types such as vector, matrix, etc. and defines operations upon them.
| viennacl::device_specific
| Provides an OpenCL kernel generator.

## Functions

void | viennacl::device_specific::compute_reduction (utils::kernel_generation_stream &os, std::string acc, std::string cur, scheduler::op_element const &op)
void | viennacl::device_specific::compute_index_reduction (utils::kernel_generation_stream &os, std::string acc, std::string cur, std::string const &acc_value, std::string const &cur_value, scheduler::op_element const &op)
void | viennacl::device_specific::process_all (std::string const &type_key, std::string const &str, utils::kernel_generation_stream &stream, std::vector< mapping_type > const &mappings)
void | viennacl::device_specific::process_all_at (std::string const &type_key, std::string const &str, utils::kernel_generation_stream &stream, std::vector< mapping_type > const &mappings, vcl_size_t root_idx, leaf_t leaf)
std::string | viennacl::device_specific::neutral_element (scheduler::op_element const &op)

## Detailed Description

A collection of utilities for the device specific execution templates.

Definition in file utils.hpp.